#ifndef STATE_UPDATER_HH
#define STATE_UPDATER_HH

template <class ScalarVector, class Vector> class StateUpdater {
public:
  virtual void nextTimeStep() = 0;
  virtual void setup(double _tau) = 0;
  virtual void solve(Vector const &velocity_field) = 0;
  virtual void extractLogState(ScalarVector &logState) = 0;
};

#endif
